



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>51nod-1686 第K大区间(二分+尺取法)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">51nod-1686 第K大区间(二分+尺取法)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 07:48:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接：</p>
<p><a href="https://www.51nod.com/onlineJudge/questionCode.html#!problemId=1686" rel="external nofollow noreferrer">第K大区间</a></p>
<div>
<div>
<div>基准时间限制：1&nbsp;秒 空间限制：131072&nbsp;KB&nbsp;</div>
</div>
<div>
<div>&nbsp;</div>
</div>
</div>
<div>
<div>
<p>定义一个区间的值为其众数出现的<strong>次数</strong>。<br />现给出n个数，求将所有区间的值排序后，第K大的值为多少。</p>
</div>
</div>
<div>
<div>
<div><strong>Input</strong></div>
<pre class="prettyprint linenums">第一行两个数n和k(1&lt;=n&lt;=100000,k&lt;=n*(n-1)/2)<br />
第二行n个数，0&lt;=每个数&lt;2^31</pre>
<div><strong>Output</strong></div>
<pre class="prettyprint linenums">一个数表示答案。</pre>
<div>&nbsp;</div>
<div>Input示例</div>
<pre class="prettyprint linenums">4&nbsp;2<br />
1&nbsp;2&nbsp;3&nbsp;2</pre>
<div>&nbsp;</div>
<div>Output示例</div>
<pre class="prettyprint linenums">2

<strong>题意：</strong>

<strong>思路：</strong>

先把数组都离散为[1,n]的数,注意相等的;<br />再二分答案t,check区间众数大于等于t的区间有多少个;(可以设区间众数大于等于t的区间为合法区间)<br />check的时候采用尺取法,按顺序枚举每个区间的左端点i,然后找到区间右端点的最小值;以这个左端点为合法区间的方案数为n-(r-1);<br />复杂度为O(nlogn)

<strong>AC代码：</strong>
</pre>
<div>
<pre class="prettyprint linenums">//#include &lt;bits/stdc++.h&gt;<br />
#include &lt;vector&gt;<br />
#include &lt;iostream&gt;<br />
#include &lt;queue&gt;<br />
#include &lt;cmath&gt;<br />
#include &lt;map&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;cstdio&gt;

using namespace std;<br />
#define Riep(n) for(int i=1;i&lt;=n;i++)<br />
#define Riop(n) for(int i=0;i&lt;n;i++)<br />
#define Rjep(n) for(int j=1;j&lt;=n;j++)<br />
#define Rjop(n) for(int j=0;j&lt;n;j++)<br />
#define mst(ss,b) memset(ss,b,sizeof(ss));<br />
typedef long long LL;<br />
template&lt;class T&gt; void read(T&amp;num) {<br />
    char CH; bool F=false;<br />
    for(CH=getchar();CH&lt;''||CH&gt;'';F= CH=='-',CH=getchar());<br />
    for(num=;CH&gt;=''&amp;&amp;CH&lt;='';num=num*+CH-'',CH=getchar());<br />
    F &amp;&amp; (num=-num);<br />
}<br />
int stk[], tp;<br />
template&lt;class T&gt; inline void print(T p) {<br />
    if(!p) { puts(""); return; }<br />
    while(p) stk[++ tp] = p%, p/=;<br />
    while(tp) putchar(stk[tp--] + '');<br />
    putchar('\n');<br />
}

const LL mod=1e9+;<br />
const double PI=acos(-1.0);<br />
const LL inf=1e10;<br />
const int N=1e5+;

int n,k;<br />
int a[N],flag[N];<br />
struct node<br />
{<br />
    int a,id,ans;<br />
}po[N];<br />
int cmp(node x,node y)<br />
{<br />
    if(x.a==y.a)return x.id&lt;y.id;<br />
    return x.a&lt;y.a;<br />
}<br />
int cmp1(node x,node y)<br />
{<br />
    return x.id&lt;y.id;<br />
}

int check(int x)<br />
{<br />
    mst(flag,);<br />
    LL ans=;<br />
    int num=;<br />
    int r=;<br />
    Riep(n)<br />
    {<br />
        while()<br />
        {<br />
            int pos=po[r].ans;<br />
          if(pos!=-) if(flag[pos]&gt;=x||r&gt;n)break;<br />
            r++;<br />
            pos=po[r].ans;<br />
            flag[pos]++;<br />
        }<br />
        ans=ans+n-(r-);<br />
        flag[po[i].ans]--;<br />
    }<br />
    if(ans&gt;=k)return ;<br />
    return ;<br />
}

int main()<br />
{<br />
    read(n);read(k);<br />
    Riep(n)read(po[i].a),po[i].id=i;<br />
    sort(po+,po+n+,cmp);<br />
    po[].ans=po[].a=-;<br />
    Riep(n)<br />
    {<br />
        if(po[i].a!=po[i-].a)po[i].ans=i;<br />
        else po[i].ans=po[i-].ans;<br />
    }<br />
    sort(po+,po+n+,cmp1);

    int l=,r=n;<br />
    while(l&lt;=r)<br />
    {<br />
        int mid=(l+r)&gt;&gt;;<br />
        if(check(mid))l=mid+;<br />
        else r=mid-;<br />
    }<br />
    print(l-);<br />
    return ;<br />
}</pre>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e20vx8.html">zabbix的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd4x00q.html">安装生物信息学软件-R</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k34l3q.html">android 2&period;2 videoView 诡异bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okk3me9.html">karma&plus;angular</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdej3pz9.html">&lbrack;转载&rsqb;--用Python 自动安装软件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wz00lq.html">【贪心】XMU 1061  Ckp的约会</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2dn09.html">python遗传算法实现数据拟合</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjlj5d9.html">Query语句对系统性能的影响</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgnpgd8.html">JAVA内容回顾（二）&mdash;&mdash;面向对象（OOP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yv37g8.html">【方法】Html5实现文件异步上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jg5pw8.html">python进阶学习（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj2yd19.html">Pazera Free Audio Extractor 中文版 - 轻松将视频背景音乐&sol;对话音频提取出来的免费软件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zvdv09.html">mac os x下的程序快速切换快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jpr00q.html">【Qt】Qt Quick 之 QML 与 C&plus;&plus; 混合编程详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2zyp19.html">【blog】SpringBoot如何搭建聚合项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyjkvx9.html">HNU 2015暑期新队员训练赛2 H Blanket</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwve45r8.html">Python巧用正则表达式，完成接口参数替换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppjzpz9.html">Gift动图分解小工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1lpl09.html">ubuntu&lpar;14&period;04&rpar; 下安装yaf拓展</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4dymxq.html">JS - 常用效果代码库 &lpar;四&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95xmknv8.html">Firefox 设置技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o7w1j9.html">C：指针</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm47e79.html">当类库项目中无法使用Application&period;StartupPath</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0n3pgq.html">spring4 定时任务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvzlkxq.html">学习JQuery中文文档之get&lpar;&rpar;函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wmrw3q.html">jQuery hover事件鼠标滑过图片半透明标题文字滑动显示隐藏</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vjwlm8.html">mysql 加入列，改动列，删除列。</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnlo30q.html">微信lbs---返回两个经纬度坐标点的距离</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yngpnq.html">如何选择Javascript模板引擎（javascript template engine&rpar;？</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mnzzjq.html">LINUX内核笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
